%define name FJSVdr-util-SLES12
%define version 1.3.0
%define release 1

%define dp_home_dir    /opt/FJSVdr-util
%define dp_etc_dir     /opt/FJSVdr-util/etc
%define dp_lib_dir     /opt/FJSVdr-util/lib
%define dp_libexec_dir /opt/FJSVdr-util/libexec
%define dp_core_dir    /opt/FJSVdr-util/libexec/dp-core
%define dp_sbin_dir    /opt/FJSVdr-util/sbin
%define dp_tools_dir   /opt/FJSVdr-util/tools
%define dp_log_dir     /opt/FJSVdr-util/var/log
%define dp_com_dir     /opt/FJSVdr-util/user_command
%define python_lib     /usr/lib/python2.7/site-packages
%define udev_rule_dir  /etc/udev/rules.d
%define systemd_dir    /usr/lib/systemd/system
%define default_grub   /etc/default/grub
%define grub_cfg       /boot/grub2/grub.cfg
%define dp_boot_opt    "pci=hpiosize=0 pci=hpmemsize=8m pciehp.pciehp_force=1"

Name:        %{name}
Version:     %{version}
Release:     %{release}
Summary:     Dynamic Reconfiguration utility for PRIMEQUEST 2000 series

Group:       System Environment/Base
License:     GPLv2
Vendor:      FUJITSU LIMITED
Packager:    FUJITSU LIMITED
URL:         http://www.fujitsu.com/
Source0:     %{name}-%{version}.tar.bz2
Source1:     10-FJSVdr-util-kdump-restart
Source2:     90-FJSVdr-util-detect-passthrough-dev
Source3:     89-FJSVdr-util-irqbalance-restart
Source4:     87-FJSVdr-util-libvirtd-restart
BuildRoot:   %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:   noarch
Requires:    python >= 2.7
Requires:    ipmitool
Requires:    kexec-tools
Requires:    OpenIPMI

%description
Provides a set of Dynamic Reconfiguration command user interface
and related service scripts. And also provides some Dynamic
Reconfiguration collaborate scripts.

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{dp_etc_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_lib_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_libexec_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_core_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_sbin_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_tools_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_log_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_com_dir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
mkdir -p $RPM_BUILD_ROOT%{systemd_dir}
mkdir -p $RPM_BUILD_ROOT%{udev_rule_dir}

# etc
install -m 0644 \
	etc/dr_report.conf $RPM_BUILD_ROOT%{dp_etc_dir}
# lib
install -m 0644 \
	lib/dp.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 \
	lib/ipmi.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 \
	lib/dp_compat.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 \
	lib/notify.py $RPM_BUILD_ROOT%{dp_lib_dir}
# libexec
install -m 0755 \
	libexec/udev_dp_bridge.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 \
	libexec/dp_send_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 \
	libexec/dp_send_not_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 \
	libexec/dp_event_daemon.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 \
	libexec/dp_event_notifier.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 \
	libexec/dp_enable_removable_sb.py $RPM_BUILD_ROOT%{dp_libexec_dir}
# dp-core
install -m 0755 \
	libexec/dp-core/dp_add.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 \
	libexec/dp-core/dp_rm.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 \
	libexec/dp-core/dp_show.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 \
	libexec/dp-core/dp_stat.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 \
	libexec/dp-core/dp_report.py $RPM_BUILD_ROOT%{dp_core_dir}
# sbin
install -m 0755 \
	sbin/dp $RPM_BUILD_ROOT%{dp_sbin_dir}/dr
# tools
install -m 0644 \
	tools/SLES12/FJSVdr-util.rules $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
install -m 0755 \
	tools/udev_dp_bridge.sh $RPM_BUILD_ROOT%{dp_tools_dir}
# systemd service
install -m 0644 \
	tools/SLES12/FJSVdr-util-enable.service $RPM_BUILD_ROOT%{systemd_dir}
install -m 0644 \
	tools/SLES12/FJSVdr-util-event-daemon.service $RPM_BUILD_ROOT%{systemd_dir}
install -m 0644 \
	tools/SLES12/FJSVdr-util-enable-removable-sb.service $RPM_BUILD_ROOT%{systemd_dir}
# logrotate file
install -m 0644 tools/common/FJSVdr-util.logrotate \
	$RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/FJSVdr-util
# user_command
install -m 0755 %{SOURCE1} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 %{SOURCE2} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 %{SOURCE3} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 %{SOURCE4} $RPM_BUILD_ROOT%{dp_com_dir}

%post
if [ "$1" = 1 ]; then  # when rpm -i
	## install service
	/usr/bin/systemctl enable FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl enable FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl enable FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
fi

## overwrite 70-kdump.rules and 80-hotplug-cpu-mem.rules
## for kdump on SLES12
if [ -f /usr/lib/udev/rules.d/70-kdump.rules ]; then
	touch /etc/udev/rules.d/70-kdump.rules
fi
## for CPU online/offline on SLES12
if [ -f /usr/lib/udev/rules.d/80-hotplug-cpu-mem.rules ]; then
	touch /etc/udev/rules.d/80-hotplug-cpu-mem.rules
fi

## create symlinks
ln -sf $RPM_BUILD_ROOT%{dp_sbin_dir}/dr /sbin/dr
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp.py %{python_lib}/dp.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/ipmi.py %{python_lib}/ipmi.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp_compat.py %{python_lib}/dp_compat.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/notify.py %{python_lib}/notify.py

DP_BOOT_OPT=%{dp_boot_opt}
if [ -f %{default_grub} ]; then
        GRUB_CMDLINE_LINUX=`cat %{default_grub} | grep '^GRUB_CMDLINE_LINUX='|sed -e 's/GRUB_CMDLINE_LINUX=//g' | sed -e 's/^"//g' | sed -e 's/"$//g'`
        NEW_CMDLINE=$GRUB_CMDLINE_LINUX
        for DP_OPT in ${DP_BOOT_OPT[@]}
        do
                NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$DP_OPT'\>//g')
                NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/$/ '$DP_OPT'/g')
        done
fi

# Set mem= kenrel option
NODE_MEM=()
# define 128MB because memory section of SLES12 is 128MB
SECTION_SIZE=134217728
for NODE in `ls /sys/devices/system/node|grep node|sort -r`
do
	# find first memory section in the node
	MEM=`ls /sys/devices/system/node/$NODE/|grep memory|sed -e 's/memory//g'|sort -g|head -n 1`
	# add $MEM to $NODE_MEM array
	NODE_MEM=("${NODE_MEM[@]}" $MEM)
done

# sort memory in ascending order
SORTED_MEM=($(for MEM in "${NODE_MEM[@]}"; do echo "$MEM"; done|sort -n))
# calculate mem= value. SORTED_MEM[1] is Node of HomeSB not including BSP
MEM_ALIGN=`expr ${SORTED_MEM[1]} \* 2`
MEM_ALIGN=`expr ${MEM_ALIGN} \* $SECTION_SIZE`
# convert $MEM_ALIGN from decimal to hexadecimal
MEM_ALIGN_HEX=`echo "ibase=10; obase=16; $MEM_ALIGN" | bc`
# prepare new mem= option for Haswell
NEW_MEM_OPTION="mem=0x$MEM_ALIGN_HEX"
# add mem= boot option for Hasewll
NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$NEW_MEM_OPTION'\>//g')
NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/$/ '$NEW_MEM_OPTION'/g')

# Add clocksource=hpet option
CPU_MODEL=$(awk '/^model[[:space:]]+:/{print $3}' /proc/cpuinfo | head -1)
if true
then
	# If notsc option is already set due to previous version, remove it.
	NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'notsc'\>//g')
	# If clocksource=hpet option is already set, remove it first to avoid double set.
	NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'clocksource=hpet'\>//g')
	NEW_CMDLINE=$(echo $NEW_CMDLINE clocksource=hpet)
fi

# Update grub.conf
if [ -f %{default_grub} ]; then
	NEW_CMDLINE="GRUB_CMDLINE_LINUX=\"$NEW_CMDLINE\""
	sed -i '/^GRUB_CMDLINE_LINUX=/d' %{default_grub}
	echo $NEW_CMDLINE >> %{default_grub}
	grub2-mkconfig -o %{grub_cfg} > /dev/null 2>&1
else
	exit 1
fi

%preun
if [ "$1" = 0 ]; then  # when rpm -e
	## uninstall service
	/usr/bin/systemctl --no-reload disable FJSVdr-util-enable.service \
		>/dev/null 2>&1
	/usr/bin/systemctl --no-reload disable FJSVdr-util-event-daemon.service \
		>/dev/null 2>&1
	/usr/bin/systemctl --no-reload disable FJSVdr-util-enable-removable-sb.service \
		>/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1

	## cleanup symlinks
	if [ -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py ];
	then
		rm -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py
	fi
	if [ -f /sbin/dr ];
	then
		rm -f /sbin/dr
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/notify.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/notify.py
	fi
fi

%postun
if [ "$1" = 0 ]; then	# when rpm -e
    ## remove boot option for DR
	DP_BOOT_OPT=%{dp_boot_opt}
	if [ -f %{default_grub} ]; then
		GRUB_CMDLINE_LINUX=`cat %{default_grub} | grep '^GRUB_CMDLINE_LINUX='|sed -e 's/GRUB_CMDLINE_LINUX=//g' | sed -e 's/^"//g' | sed -e 's/"$//g'`
		NEW_CMDLINE=$GRUB_CMDLINE_LINUX
		for DP_OPT in ${DP_BOOT_OPT[@]}
		do
		        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$DP_OPT'\>//g')
		done
		# cleanup mem=boot option for Haswell
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'mem=[a-zA-Z0-9]*'\>//g')
		# cleanup clocksource=hpet option for PQ2k Type1 and PQ2k Type2
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'clocksource=hpet'\>//g')

		NEW_CMDLINE="GRUB_CMDLINE_LINUX=\"$NEW_CMDLINE\""

		sed -i '/^GRUB_CMDLINE_LINUX=/d' %{default_grub}
		echo $NEW_CMDLINE >> %{default_grub}
		grub2-mkconfig -o %{grub_cfg} > /dev/null 2>&1
	else
		exit 1
	fi
	## for kdump
	if [ -f /etc/udev/rules.d/70-kdump.rules ]; then
		/bin/rm -rf /etc/udev/rules.d/70-kdump.rules
	fi
	## for CPU online/offline
	if [ -f /etc/udev/rules.d/80-hotplug-cpu-mem.rules ]; then
		/bin/rm -rf /etc/udev/rules.d/80-hotplug-cpu-mem.rules
	fi
fi
/usr/bin/systemctl daemon-reload >/dev/null 2>&1
if [ "$1" -ge 1 ]; then # upgrade, not uninstall
	/usr/bin/systemctl try-restart \
		FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl try-restart \
		FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl try-restart \
		FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
fi

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{dp_home_dir}
%config(noreplace) %{dp_etc_dir}/dr_report.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/FJSVdr-util
%{systemd_dir}/FJSVdr-util-enable.service
%{systemd_dir}/FJSVdr-util-event-daemon.service
%{systemd_dir}/FJSVdr-util-enable-removable-sb.service
%{udev_rule_dir}/96-FJSVdr-util.rules

%changelog
* Mon Oct 24 2016 FUJITSU LIMITED
- Specify clocksource=hpet option instead of notsc avoid kdump looping
- (BS01627)

* Fri Apr 8 2016 FUJITSU LIMITED
- Do not send IPMI in case of failure after ejecting SB
- (BS01624)

* Fri Mar 4 2016 FUJITSU LIMITED
- Specify notsc option not only PQ2K Type1 and Type2, but Type3 or later
- (BS01621)

* Fri Jan 1 2016 FUJITSU LIMITED
- first build
- (BS01619)

